package fr.mael.jiwigo.dao;

import java.io.IOException;
import java.util.List;

import fr.mael.jiwigo.om.Image;
import fr.mael.jiwigo.om.Tag;
import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;

public interface TagDao {
    /**
     * lists the tags
     * @return the list of tags
     * @throws IOException
     * @throws ProxyAuthenticationException
     */
    public List<Tag> list() throws IOException, ProxyAuthenticationException;

    /**
     * Creation of a tag
     * @param tag the tag to create
     * @return true if the tag as been successfully created
     * @throws ProxyAuthenticationException
     */
    public boolean create(Tag tag) throws ProxyAuthenticationException;

    /**
     * Function that returns the tags for an image
     * @param image the image
     * @return the tags list
     * @throws IOException
     * @throws ProxyAuthenticationException
     */
    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException;
}
